--- bookmarkservice.php	2006-04-27 01:50:36.000000000 +0200
+++ bookmarkservice.php.modified	2006-11-11 21:41:51.000000000 +0100
@@ -247,9 +247,14 @@
 
         // Set up the SQL query.
         $query_1 = 'SELECT DISTINCT ';
-        if (SQL_LAYER == 'mysql4') {
-            $query_1 .= 'SQL_CALC_FOUND_ROWS ';
-        }
+
+        // changes by mc
+        // for changes introduced to cope with ordering problems
+        // we are using this in a subselect, so we have the SQL_CAL_FOUND_ROWS
+        // in the outer select, not in the inner...
+//      if (SQL_LAYER == 'mysql4') {
+//          $query_1 .= 'SQL_CALC_FOUND_ROWS ';
+//      }
         $query_1 .= 'B.*, U.'. $userservice->getFieldName('username');
 
         $query_2 = ' FROM '. $userservice->getTableName() .' AS U, '. $GLOBALS['tableprefix'] .'bookmarks AS B';
@@ -275,21 +280,27 @@
         switch($sortOrder) {
             case 'date_asc':
                 $query_5 = ' ORDER BY B.bDatetime ASC ';
+		$order_by= ' ORDER BY bDatetime ASC ';
                 break;
             case 'title_desc':
                 $query_5 = ' ORDER BY B.bTitle DESC ';
+		$order_by= ' ORDER BY bTitle DESC ';
                 break;
             case 'title_asc':
                 $query_5 = ' ORDER BY B.bTitle ASC ';
+                $order_by= ' ORDER BY bTitle ASC ';
                 break;
             case 'url_desc':
                 $query_5 = ' ORDER BY B.bAddress DESC ';
+                $order_by= ' ORDER BY bAddress DESC ';
                 break;
             case 'url_asc':
                 $query_5 = ' ORDER BY B.bAddress ASC ';
+                $order_by= ' ORDER BY bAddress ASC ';
                 break;
             default:
                 $query_5 = ' ORDER BY B.bDatetime DESC ';
+                $order_by= ' ORDER BY bDatetime DESC ';
         }
 
         // Handle the parts of the query that depend on any tags that are present.
@@ -337,8 +348,19 @@
             $query_4 .= ' AND B.bHash = "'. $hash .'"';
         }
 
+        // $query = $query_1 . $query_2 . $query_3 . $query_4 . $query_5;
+
+	// changed by mc 
+	// as DISTINCT and ORDER BY have some issues in MySQL
+	// (cmp. http://bugs.mysql.com/bug.php?id=815)
+	// we need to wrap it in another select and order this one
         $query = $query_1 . $query_2 . $query_3 . $query_4 . $query_5;
-        if (!($dbresult = & $this->db->sql_query_limit($query, intval($perpage), intval($start)))) {
+        if (SQL_LAYER == 'mysql4') {
+	    $query = "SELECT SQL_CALC_FOUND_ROWS * FROM (" . $query . ") as SubSelect " . $order_by ;
+	} else {
+	    $query = "SELECT * FROM (" . $query . ") as SubSelect " . $order_by ;
+	}
+	if (!($dbresult = & $this->db->sql_query_limit($query, intval($perpage), intval($start)))) {
             message_die(GENERAL_ERROR, 'Could not get bookmarks', '', __LINE__, __FILE__, $query, $this->db);
             return false;
         }
